// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "piskvorky.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() : na_tahu(1)
{
	pocet_o=pocet_x=0;
	vypo= new vypocetbase; Okdo=0;
	vypx= new vypocet4; Xkdo=4;

	m_pdcMemory= new CDC;
	m_pBitmap= new CBitmap;
}

CMainFrame::~CMainFrame()
{
	delete m_pBitmap; // already deselected
	delete m_pdcMemory;

	delete vypo;
	delete vypx;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	/*cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);*/

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////

void CMainFrame::O(CDC* pDC,int x, int y)
{
	CBrush *pOldBrush=(CBrush*)pDC->SelectStockObject(NULL_BRUSH);
	static CPen pen( PS_SOLID, 2, RGB(84,96,255)), penp(PS_SOLID, 2, RGB(106,230,255));
	if ( x==vypo->postah.x && y==vypo->postah.y ) pDC->SelectObject(penp);
	else pDC->SelectObject(pen);
	pDC->Ellipse(CRect(V_C*x+5,V_C*y+5,V_C*(x+1)-3,V_C*(y+1)-3));
	pDC->SelectObject(pOldBrush);
	pDC->SelectStockObject(BLACK_PEN);
}

void CMainFrame::X(CDC* pDC,int x, int y)
{
	static CPen pen( PS_SOLID, 2, RGB(240,244,64)), penp(PS_SOLID, 2, RGB(252,253,213)/*(60,236,152)*/);
	if ( x==vypx->postah.x && y==vypx->postah.y ) pDC->SelectObject(penp);
	else pDC->SelectObject(pen);
	pDC->MoveTo( V_C*x+5,     V_C*y+5); pDC->LineTo( V_C*(x+1)-4, V_C*(y+1)-4);
	pDC->MoveTo( V_C*x+5, V_C*(y+1)-4); pDC->LineTo( V_C*(x+1)-4,     V_C*y+5);
	pDC->SelectStockObject(BLACK_PEN);
}

void CMainFrame::OnDraw(CDC* dc)
{
	int i,j;
	CString str;
	
/*nakresli papir*/ dc->Rectangle(CRect(0,0,V_X*V_C+1,V_Y*V_C+1));
	for (i=0; i<V_Y+1; i++) { dc->MoveTo( 0, i*V_C); dc->LineTo(V_X*V_C, i*V_C); }
	for (i=0; i<V_X+1; i++) { dc->MoveTo( i*V_C, 0); dc->LineTo( i*V_C,V_Y*V_C); }

/*nakresli kolecka a krizky*/
	for (i=0; i<V_X; i++) for (j=0; j<V_Y; j++)	{
		/*O*/if (vypo->a(i,j)==1) O(dc,i,j);
		/*X*/else if (vypo->a(i,j)==2) X(dc,i,j);
		#ifdef BODY
			for (int k=0; k<vypo->pole_bodu[0][i][j]; k++) dc->SetPixel(i*V_C+2+2*k, j*V_C+2, RGB(84,96,235));
			for (k=0; k<vypo->pole_bodu[1][i][j]; k++) dc->SetPixel(i*V_C+2+2*k, j*V_C+4, RGB(240,244,64));
		#endif
	}
	if (vypo->pet) {
		static CPen pen( PS_SOLID, 2, RGB(248,78,48));
		dc->SelectObject(pen);
		dc->MoveTo( vypo->pet_od.x*V_C+V_C/2, vypo->pet_od.y*V_C+V_C/2);
		dc->LineTo( vypo->pet_do.x*V_C+V_C/2, vypo->pet_do.y*V_C+V_C/2);
		dc->SelectStockObject(BLACK_PEN);
	}

/*vysledky*/
	if (na_tahu==1) O(dc,V_X,0); else X(dc,V_X,0);
	dc->Rectangle( (V_X+1)*V_C, 0, (V_X+2)*V_C, 2*V_C);
	dc->Rectangle( (V_X+2)*V_C-1, 0, (V_X+10)*V_C, 2*V_C);
	O(dc,V_X+1,0); X(dc,V_X+1,1);
	for (i=1; i<=pocet_o%51; i++) if ( i%5==0) {
		dc->MoveTo(  (V_X+2)*V_C+(i-5)*3+2, V_C/2+4); dc->LineTo( (V_X+2)*V_C+i*3+2, V_C/2-4);
	} else { dc->MoveTo( (V_X+2)*V_C+i*3+2, V_C/2-6); dc->LineTo( (V_X+2)*V_C+i*3+2, V_C/2+6);}
	for (i=1; i<=pocet_x%51; i++) if ( i%5==0) {
		dc->MoveTo(  (V_X+2)*V_C+(i-5)*3+2, V_C*3/2+4); dc->LineTo( (V_X+2)*V_C+i*3+2, V_C*3/2-4);
	} else { dc->MoveTo( (V_X+2)*V_C+i*3+2, V_C*3/2-6); dc->LineTo( (V_X+2)*V_C+i*3+2, V_C*3/2+6);}

/*uroven*/
	#define M_X (V_X+1)*V_C	//x-ova souradnice menu
	#define M_Y 3*V_C		//y-ova souradnice menu
	dc->Rectangle(       M_X,     M_Y, M_X+6*V_C, M_Y+7*V_C);
	dc->Rectangle( M_X+4*V_C, M_Y+V_C, M_X+6*V_C, M_Y+7*V_C);
	str.Format("znova");
	dc->Rectangle( M_X, M_Y, M_X+4*V_C+1, M_Y+V_C+1);
	dc->Rectangle( M_X+1, M_Y+1, M_X+4*V_C, M_Y+V_C);
	dc->TextOut( M_X+4*V_C-5, M_Y+2, str);
	str.Format("clovek"); dc->TextOut( M_X+4*V_C-5, M_Y+1*V_C+2, str);
	str.Format("Comp 1"); dc->TextOut( M_X+4*V_C-5, M_Y+2*V_C+2, str);
	str.Format("Comp 2"); dc->TextOut( M_X+4*V_C-5, M_Y+3*V_C+2, str);
	str.Format("Comp 3"); dc->TextOut( M_X+4*V_C-5, M_Y+4*V_C+2, str);
	str.Format("Comp 4"); dc->TextOut( M_X+4*V_C-5, M_Y+5*V_C+2, str);
	str.Format( "vyvoj"); dc->TextOut( M_X+4*V_C-5, M_Y+6*V_C+2, str);
	O( dc, 1+V_X+4, 3); X( dc, 1+V_X+5, 3);
	for (i=0; i<6; i++) {
		dc->Ellipse(CRect( M_X+4*V_C+5, M_Y+(i+1)*V_C+5, M_X+5*V_C-5, M_Y+(i+2)*V_C-5));
		dc->Ellipse(CRect( M_X+5*V_C+5, M_Y+(i+1)*V_C+5, M_X+6*V_C-5, M_Y+(i+2)*V_C-5));
	}
	dc->Ellipse(CRect( M_X+4*V_C+8, M_Y+(Okdo+1)*V_C+8, M_X+5*V_C-8, M_Y+(Okdo+2)*V_C-8));
	dc->Ellipse(CRect( M_X+5*V_C+8, M_Y+(Xkdo+1)*V_C+8, M_X+6*V_C-8, M_Y+(Xkdo+2)*V_C-8));
}

void CMainFrame::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	/*nahrada za fci OnInitialUpdate*/static po_prve=1;
	if (po_prve) {
		po_prve=0;
		if (m_pdcMemory->GetSafeHdc() == NULL) {
			CClientDC dc(this);
			CRect rectMax(0,0,1024,768);//GetClientRect(rectMax);
			m_pdcMemory->CreateCompatibleDC(&dc);
			// makes bitmap same size as display window
			m_pBitmap->CreateCompatibleBitmap(&dc, rectMax.right, rectMax.bottom);
		}
	}

	CRect rectUpdate;
	dc.GetClipBox(&rectUpdate);
	CBitmap* pOldBitmap = m_pdcMemory->SelectObject(m_pBitmap);
	m_pdcMemory->SelectClipRgn(NULL);
	m_pdcMemory->IntersectClipRect(&rectUpdate);
	CBrush backgroundBrush((COLORREF) ::GetSysColor(COLOR_3DFACE));
	CBrush* pOldBrush = m_pdcMemory->SelectObject(&backgroundBrush);
	m_pdcMemory->PatBlt(rectUpdate.left, rectUpdate.top, rectUpdate.Width(),
		rectUpdate.Height(), PATCOPY);
/*vyplne*/CBrush poz( RGB(164,169,150) );
	m_pdcMemory->SelectObject(poz);//vypln ctverce a kruhu
/*text*/m_pdcMemory->SetBkMode(TRANSPARENT);//pruhledny text
/*font*/CFont font, *pOldFont;
	font.CreateFont(V_C-2, 8, 0, 0, 400, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, 
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_ROMAN, NULL);
	pOldFont=m_pdcMemory->SelectObject(&font); m_pdcMemory->SetTextAlign( TA_RIGHT);

	OnDraw(m_pdcMemory);

	m_pdcMemory->SelectStockObject(NULL_BRUSH);//vypln ctverce a kruhu
	dc.BitBlt(rectUpdate.left, rectUpdate.top, rectUpdate.Width(), rectUpdate.Height(),
		m_pdcMemory, rectUpdate.left, rectUpdate.top, SRCCOPY);
	m_pdcMemory->SelectObject(pOldBitmap);
	m_pdcMemory->SelectObject(pOldBrush);
	m_pdcMemory->SelectObject(pOldFont);

/*hra pocitace*/
	IdlimIdlisIdlime();//!!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!!

	// Do not call CWnd::OnPaint() for painting messages}
}

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (vypo->pet) {
		vypo->pet=0; vypo->smaz_vse(); vypx->smaz_vse(); kresli_vse(); return;
	}

	//nova hra
	static CRect ctvNovaH( M_X, M_Y, M_X+4*V_C, M_Y+V_C);
	if (ctvNovaH.PtInRect(point)) {
		pocet_o=0; pocet_x=0;
		vypo->pet=0; vypo->smaz_vse(); vypx->smaz_vse();
		kresli_vse();
		return;
	}

	//umisteni O X
	static CRect papRect(0,0,V_X*V_C,V_Y*V_C);
	if ( papRect.PtInRect(point)) if ((na_tahu==1 && Okdo==0) || (na_tahu==2 && Xkdo==0))
		if ( vypo->a(point.x/V_C,point.y/V_C)==0 ) {
			if (na_tahu==1) { vypo->postah.x=point.x/V_C; vypo->postah.y=point.y/V_C; }
			if (na_tahu==2) { vypx->postah.x=point.x/V_C; vypx->postah.y=point.y/V_C; }
			vypo->a(point.x/V_C,point.y/V_C)=na_tahu; vypx->a(point.x/V_C,point.y/V_C)=na_tahu;
			if (vypo->ox5vr())
				if (na_tahu==1) //{ if (++pocet_o>50) pocet_o=0;} else { if (++pocet_x>50) pocet_x=0;}
					pocet_o++; else pocet_x++;
			na_tahu=3-na_tahu;
			kresli_vse(); return;
	} 

	//nastaveni obtiznosti
	int i,j,k;
	for (i=0; i<6; i++) {
		CRect ctvO( M_X+4*V_C+1, M_Y+(i+1)*V_C+1, M_X+5*V_C-1, M_Y+(i+2)*V_C-1),
			  ctvX( M_X+5*V_C+1, M_Y+(i+1)*V_C+1, M_X+6*V_C-1, M_Y+(i+2)*V_C-1);
		if (ctvO.PtInRect(point)) {
			if (Okdo!=i && i!=0) {
				delete vypo;
				switch (i) {
					case 1:vypo=new vypocet1; break;
					case 2:vypo=new vypocet2; break;
					case 3:vypo=new vypocet3; break;
					case 4:vypo=new vypocet4; break;
					case 5:vypo=new vypocet5; break;
				}
				for (j=0;j<V_C;j++) for (k=0;k<V_C;k++) vypo->a(j,k)=vypx->a(j,k);
			}
			Okdo=i; kresli_vse(); return;
		}
		if (ctvX.PtInRect(point)) {
			if (Xkdo!=i && i!=0) {
				delete vypx;
				switch (i) {
					case 1:vypx=new vypocet1; break;
					case 2:vypx=new vypocet2; break;
					case 3:vypx=new vypocet3; break;
					case 4:vypx=new vypocet4; break;
					case 5:vypx=new vypocet5; break;
				}
				for (j=0;j<V_C;j++) for (k=0;k<V_C;k++) vypx->a(j,k)=vypo->a(j,k);
			}
			Xkdo=i; kresli_vse(); return;
		}
	}

	CFrameWnd::OnLButtonDown(nFlags, point);
}

void CMainFrame::kresli_vse()
{
	CRect clientRect;
	GetClientRect(clientRect);
	InvalidateRect(CRect(0,0,clientRect.right,clientRect.bottom),FALSE);
}

void CMainFrame::IdlimIdlisIdlime()
{
	if (na_tahu==1 && Okdo>0) {
		if (vypo->pet) { vypo->pet=0; vypo->smaz_vse(); vypx->smaz_vse(); kresli_vse(); return; }
		if (vypo->tah(na_tahu)) { //kdyz neni kam hrat
			vypo->smaz_vse(); vypx->smaz_vse(); kresli_vse(); return;
		}
		vypx->a( vypo->postah.x, vypo->postah.y)=na_tahu;
		if (vypo->ox5vr()) {pocet_o++;TRACE("poco %d, pocx %d\n",pocet_o,pocet_x);}//if (++pocet_o>50) pocet_o=0;
		na_tahu=3-na_tahu; kresli_vse();
	} else if (na_tahu==2 && Xkdo>0) {
		if (vypo->pet) { vypo->pet=0; vypo->smaz_vse(); vypx->smaz_vse(); kresli_vse(); return; }
		if (vypx->tah(na_tahu)) { //kdyz neni kam hrat
			vypo->smaz_vse(); vypx->smaz_vse(); kresli_vse(); return;
		}
		vypo->a( vypx->postah.x, vypx->postah.y)=na_tahu;
		if (vypo->ox5vr()) {pocet_x++;TRACE("poco %d, pocx %d\n",pocet_o,pocet_x);}//if (++pocet_x>50) pocet_x=0;
		na_tahu=3-na_tahu; kresli_vse();
	}
}
