// vypocet2.cpp: implementation of the vypocet2 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vypocet2.h"

//////////////////////////////////////////////////////////////////////
// vypocet2

vypocet2::vypocet2()
{
	nazev.Format("Comp2");
}

int vypocet2::tah(int kdo)
{
	hra_k_ostatnim();
	if (postah.x==V_X/2 && postah.y==V_Y/2) {
		if ( a(postah.x,postah.y)!=0) return 1;
		else { a(postah.x,postah.y)=kdo; return 0; }
	}
	int x1,y1,ret1,ret2;
	ret1=vyhra_do_3_tahu(  kdo); x1=postah.x; y1=postah.y;
	ret2=vyhra_do_3_tahu(3-kdo);
	if (ret1>=ret2) { postah.x=x1; postah.y=y1; }
	if ( ret1==0 && ret2==0) hra_k_ostatnim();

	//TRACE("tah2()%d %d ox:%d\n",postah.x,postah.y,kdo);
	if ( a(postah.x,postah.y)!=0) return 1;
	a(postah.x,postah.y)=kdo;
	
	return 0;
}

int vypocet2::vyhra_do_3_tahu(int kdo)
{
	int p[V_X][V_Y];
	int i, j, k, l, x, y, vect, dx, dy, b, nahoda=0, nahodakolik=0;
	const static int mat_KB[ ][9]= {{0,1,1,0,0,0,3,3,3},	// vect: -	//
									{0,1,0,1,0,0,3,3,3},	//   / | \	//
									{3,0,1,1,0,0,3,3,3},
									{3,0,1,0,0,1,0,3,3},
									{3,3,0,1,0,1,0,3,3},
									{3,3,0,1,0,0,1,0,3},
									{3,3,3,0,0,1,1,0,3},
									{3,3,3,0,0,1,0,1,0},
									{3,3,3,0,0,0,1,1,0}};

	for (i=0; i<V_X; i++) for (j=0; j<V_Y; j++) p[i][j]=0;
	for (i=1; i<V_X-1; i++) for (j=1; j<V_Y-1; j++) for (vect=0; vect<4; vect++) {
		switch (vect) {
			case 0: dx=1; dy=0; break;
			case 1: dx=1; dy=1; break;
			case 2: dx=0; dy=1; break;
			case 3: dx=-1; dy=1;
		}
		for (k=0; k<9; k++)	{ // k..radek, l..sloupec
			x=i+dx*(-5); y=j+dy*(-5); b=0;
			for (l=0; l<9; l++) {
				x+=dx; y+=dy;
				if ( mat_KB[k][l]==0 ) {
					if (l==4 && pole[x][y]!=0) { b=1; break; }
					if (x<0 || y<0 || x>=V_X || y>=V_Y) { b=1; break; }
					if (pole[x][y]==3-kdo) { b=1; break; }
				} else if ( mat_KB[k][l]==1 ) {
					if (x<0 || y<0 || x>=V_X || y>=V_Y) { b=1; break; }
					if (pole[x][y]!=kdo) { b=1; break; }
				}
			}
			if (!b) p[i][j]++;
		}
	}

	for ( i=0; i<V_X; i++) for (j=0; j<V_Y; j++) {
		#ifdef BODY
			pole_bodu[kdo-1][i][j]=p[i][j];
		#endif

		if ( p[i][j]>nahodakolik ) {
			nahoda=0; nahodakolik=p[i][j];
		} 
		if ( p[i][j]==nahodakolik ) {
			nahoda++; if ( rand()%nahoda==0 ) { postah.x=i; postah.y=j; }
		}
	}
	return nahodakolik;
}
