// vypocet4.cpp: implementation of the vypocet4 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vypocet4.h"

//////////////////////////////////////////////////////////////////////
// vypocet4

vypocet4::vypocet4()
{
	nazev.Format("Comp4");
}

int vypocet4::tah(int kdo)
{
	int kol;
	hra_k_ostatnim();
	if (postah.x==V_X/2 && postah.y==V_Y/2) {
		if ( a(postah.x,postah.y)!=0) return 1;
		else { a(postah.x,postah.y)=kdo; return 0; }
	}

	if ( rekurze(kdo,0,0,kol)==0 && (kol>20||kol<-20) ) hra_k_ostatnim();
	
	//TRACE("tah4()%d %d ox:%d\n",postah.x,postah.y,kdo);
	if ( a(postah.x,postah.y)!=0) return 1;
	a(postah.x,postah.y)=kdo;

	return 0;
}

int vypocet4::rekurze(int kdo, int potapec, int potmax, int &kol)
{/*ret: -10(nejhorsi (vyhraje 3-kdo))..10(nejlepsi (vyhraje kdo))*/
	//10 8 6 3 2 0 -2 -3 -4 -5 -6 -7 -8 -9 -10//
	int x1,y1,ret1,ret2,ret1kol,ret2kol,i,j,k,l, pom, retmax=-20, retkolmax=0, retpoc=0;
	Tpostah post;

	if ( vyhra_do_1_tahu(  kdo) ) return 20;
	ret1=vyhra_do_1_tahu(3-kdo);
	if (ret1>1) return -20;
	if (ret1==1) return -19;
	if ( vyhra_do_2_tahu(  kdo) ) return 18;
	if ( vyhra_do_2_tahu(3-kdo) ) return -18;
	ret1=vyhra_do_3_tahu4(  kdo, ret1kol); x1=postah.x; y1=postah.y;
		if (ret1==7) ret1=8; if ( ret1==4 || ret1==5 ) ret1=6;
	ret2=vyhra_do_3_tahu4(3-kdo, ret2kol);
		if (ret2==7) ret2=8; if ( ret2==4 || ret2==5 ) ret2=6;
	if ( ret1>=ret2 ) { postah.x=x1; postah.y=y1; ret2=ret1; ret2kol=ret1kol; }
	if ( potapec>=potmax || ret2>8)
		if (ret1>=ret2) { kol=ret1kol; return ret1; } else { kol=-ret2kol; return -ret2; }

	for ( i=2; i<V_X-2; i++) for ( j=2; j<V_X-2; j++) {
		if (j==2) {
			pom=0; for ( k=0; k<5; k++) for ( l=0; l<5; l++) pom+=pole[i+k-2][l];
		} else for ( k=0; k<5; k++) pom+=pole[i+k-2][j+2]-pole[i+k-2][j-3];
		if ( pole[i][j]==0 && pom>0) {
			pole[i][j]=kdo;
			ret1=-rekurze(3-kdo,potapec+1,potmax,ret1kol); ret1kol*=-1;
			if ( ret1>retmax) { retmax=ret1; retkolmax=ret1kol; retpoc=0;
//				TRACE("retmax %d\n",retmax);
			} else if ( ret1==retmax && ret1kol>retkolmax ) { retkolmax=ret1kol; retpoc=0;
//				TRACE("retmax %d\n",retmax);
			}
			if ( ret1==retmax && ret1kol==retkolmax ) {
				retpoc++; if ( rand()%retpoc==0 ) { post.x=i; post.y=j; }
//				TRACE("retmax %d, retkolmax %d, x %d, y %d\n",retmax,retkolmax,i,j);
			}
//			TRACE("ret %d, retkol %d, x %d, y %d\n",ret1,ret1kol,i,j);
			pole[i][j]=0;
		}	
	}
	postah=post;
	kol=retpoc;
	return retmax;

}

int vypocet4::vyhra_do_3_tahu4(int kdo, int &kol)
{
	int p[V_X][V_Y];
	int i, j, k, l, x, y, vect, dx, dy, b, nahoda=0, nahodakolik=0;
	const static int mat_KB[ ][9]= {{0,1,1,0,2,0,3,3,3},	// vect: -	//
									{0,1,0,1,2,0,3,3,3},	//   / | \	//
									{3,0,1,1,3,0,3,3,3},
									{3,0,1,0,2,1,0,3,3},
									{3,3,0,1,3,1,0,3,3},
									{3,3,0,1,2,0,1,0,3},
									{3,3,3,0,3,1,1,0,3},
									{3,3,3,0,2,1,0,1,0},
									{3,3,3,0,2,0,1,1,0}};

	for (i=0; i<V_X; i++) for (j=0; j<V_Y; j++) p[i][j]=0;
	for (i=1; i<V_X-1; i++) for (j=1; j<V_Y-1; j++) for (vect=0; vect<4; vect++) {
		switch (vect) {
			case 0: dx=1; dy=0; break;
			case 1: dx=1; dy=1; break;
			case 2: dx=0; dy=1; break;
			case 3: dx=-1; dy=1;
		}
		for (k=0; k<9; k++)	{ // k..radek, l..sloupec
			x=i+dx*(-5); y=j+dy*(-5); b=0;
			for (l=0; l<9; l++) {
				x+=dx; y+=dy;
				if (l==4 && pole[x][y]!=0) { b=1; break; }
				else if ( mat_KB[k][l]==0 ) {
					if (x<0 || y<0 || x>=V_X || y>=V_Y) { b=1; break; }
					if (pole[x][y]==3-kdo) { b=1; break; }
				} else if ( mat_KB[k][l]==1 ) {
					if (x<0 || y<0 || x>=V_X || y>=V_Y) { b=1; break; }
					if (pole[x][y]!=kdo) { b=1; break; }
				}
			}
			if (!b) p[i][j]+=mat_KB[k][4];
		}
	}

	for ( i=0; i<V_X; i++) for (j=0; j<V_Y; j++) {
		#ifdef BODY
			pole_bodu[kdo-1][i][j]=p[i][j];
		#endif

		if ( p[i][j]>nahodakolik ) {
			nahoda=0; nahodakolik=p[i][j];
		} 
		if ( p[i][j]==nahodakolik ) {
			nahoda++; if ( rand()%nahoda==0 ) { postah.x=i; postah.y=j; }
		}
	}
	kol=nahoda;
	return nahodakolik;
}
